;AntiPRGM version 1.0
;Created by:MMY from The Calc Site (83p.tigalaxy.com)
;
;

;Include file needed to access system routines
 include "ti83plus.inc"  ;Incalude commands for TI83plus
_KEYHOOKON	equ 4F66h    ;B_CALL KEYHOOKON
_KEYHOOKOFF  equ 4F6Fh   ;B_CALL KEYHOOKOFF

EXT_APP equ 1   ;This definition is required of all apps
cseg            ;This linker directive is required of all apps.

;This is the application header definition area required for all apps.
 db 080h,0Fh    ;Field: Program length
 db   00h,00h,00h,00h ;Length=0 (N/A for unsigned apps)
 db 080h,012h    ;Field: Program type
 db   01h,04h  ;Type= Shareware, TI-83Plus
 db 080h,021h    ;Field: App ID
 db   01h       ;Id = 1
 db 080h,031h    ;Field: App Build
 db   01h       ;Build = 1
 db 080h,048h    ;Field: App Name
 db 041h,06Eh,074h,069h,050h,052h,047h,04Dh ;Name = "AntiPRGM" must be 8 characters
 db 080h,081h    ;Field: App Pages
 db 01h         ;App Pages = 1
 db 080h,090h    ;No default splash screen
 db 03h,026h ,09h,04h, 04h,06fh,01bh,80h     ;
 db 02h,0dh,040h                             ;
 db 0a1h ,06bh ,099h ,0f6h ,059h ,0bch ,067h 
 db 0f5h ,085h ,09ch ,09h ,06ch ,0fh ,0b4h ,03h ,09bh ,0c9h 
 db 03h ,032h ,02ch ,0e0h ,03h ,020h ,0e3h ,02ch ,0f4h ,02dh 
 db 073h ,0b4h ,027h ,0c4h ,0a0h ,072h ,054h ,0b9h ,0eah ,07ch 
 db 03bh ,0aah ,016h ,0f6h ,077h ,083h ,07ah ,0eeh ,01ah ,0d4h 
 db 042h ,04ch ,06bh ,08bh ,013h ,01fh ,0bbh ,093h ,08bh ,0fch 
 db 019h ,01ch ,03ch ,0ech ,04dh ,0e5h ,075h 
 db 80h,7Fh      ;Field: Program Image length
 db   0,0,0,0    ;Length=0, N/A
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 
;End of header data

StartApp:                  ;The app starts here
  B_CALL ClrLCDFull        ;Clear the screen
  ld a,1                   ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld a,2
  ld (curRow),a            ;Will start printing on 4th row
  ld hl, SHello            ;HL points to null-terminated string in ROM
  ld de, OP1               ;DE points to a ram buffer named OP1
  B_CALL StrCopy           ;Copy the string to ram
  ld hl, OP1               ;HL points to null-terminated string in RAM
  B_CALL PutS              ;Print the hello string from RAM
  B_CALL GetKey            ;Wait for a keypress
  B_CALL ClrLCDFull
  cp k5
  jp nz,Esc
  B_CALL GetKey            ;Wait for a keypress
  cp k1
  jp nz,Esc
  B_CALL GetKey            ;Wait for a keypress
  cp k2
  jp nz,Esc
  B_CALL GetKey            ;Wait for a keypress
  cp k3
  jp nz,Esc

GotPass:
  B_CALL ClrLCDFull        ;Clear the screen
  xor a                    ;A=0
  ld (curCol),a            ;Will start printing in left column
  xor a
  ld (curRow),a            ;Will start printing on 4th row
  ld hl, STEACH            ;HL points to null-terminated string in ROM
  ld de, OP1               ;DE points to a ram buffer named OP1
  B_CALL StrCopy           ;Copy the string to ram
  ld hl, OP1               ;HL points to null-terminated string in RAM
  B_CALL PutS              ;Print the hello string from RAM
  ld a,1                   ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld a,2
  ld (curRow),a            ;Will start printing on 4th row
  B_CALL GetKey            ;Wait for a keypress
  cp k1
  jp z,DisablePRGM
  cp k2
  jp z,EnablePRGM
  cp k3
  jp z,Esc
  jp GotPass

DisablePRGM:
  ld de, OP1               ;DE points to a ram buffer named OP1
  B_CALL StrCopy           ;Copy the string to ram
  ld hl, OP1               ;HL points to null-terminated string in RAM
  B_CALL PutS              ;Print the hello string from RAM
  ld hl,Disablekeyhook
  ld bc,hook_end-Disablekeyhook
  ld de,appbackupscreen
  ld hl,appbackupscreen	   ;
  in a,(6)		            ;Get the mem page
  B_CALL KEYHOOKON	   	;Install the key hook
  jp ShutDown

Disablekeyhook:		    	;The actual routine
	add a,e		         	;This is required for it to work (op-code:83h)
	cp kprgm	            	;prgm-key?
	jr z,disablekey	   	;Then disable it...
   ret

disablekey:
	xor a		            	;A=0
   ret

hook_end:
   jp ShutDown

EnablePRGM
  ld de, OP1               ;DE points to a ram buffer named OP1
  B_CALL StrCopy           ;Copy the string to ram
  ld hl, OP1               ;HL points to null-terminated string in RAM
  B_CALL PutS              ;Print the hello string from RAM 
  ld hl,Enablekeyhook
  ld bc,Enablehook_end-Enablekeyhook
  ld de,appbackupscreen
  ld hl,appbackupscreen	   ;
  in a,(6)		            ;Get the mem page
  B_CALL KEYHOOKOFF	    	;Install the key hook
  jp ShutDown

Enablekeyhook:		      	;The actual routine
  add a,e		         	;This is required for it to work (op-code:83h)
  cp kprgm		            ;prgm-key?
  jr z,Enablekey	      	;Then disable it...
  ret

Enablekey:
	xor a		            	;A=0
   ret

Enablehook_end:
ShutDown:
  B_CALL ClrLCDFull        ;Clear the screen
  xor a                    ;A=0
  ld (curCol),a            ;Will start printing in left column
  xor a
  ld (curRow),a            ;Will start printing on 4th row
  ld hl, SSDown            ;HL points to null-terminated string in ROM
  ld de, OP1               ;DE points to a ram buffer named OP1
  B_CALL StrCopy           ;Copy the string to ram
  ld hl, OP1               ;HL points to null-terminated string in RAM
  B_CALL PutS              ;Print the hello string from RAM
  B_CALL GetKey            ;Wait for a keypress
  DI			; disable interrupts
  LD A,001H
  OUT (003H),A		; turn off screen
  LD A,000H
  OUT (004H),A
  EX AF,AF'
  EXX
  EI			; enable interrupts
  jp Esc

Esc:
  B_CALL ClrLCDFull
  B_JUMP JForceCmdNoChar   ;Exit the application

SHello .asciz "ANTIPRGM v 1.1"

STEACH .asciz "Welcome!                        1:Disable PRGM  2:Enable PRGM   3:Exit(NoChange)"

SSDown .asciz "To finish key   blocking, This  calculator will turn itself off.Turn it back on,and the settingswill take       effect."

SEND .asciz "Please turn     power off, then back on to      finish Key      Blocking.                  "
